﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Text.RegularExpressions;

namespace howto_search_pi
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // The digits of pi.
        private string Pi;

        // Load the digits of pi.
        private void Form1_Load(object sender, EventArgs e)
        {
            Pi = File.ReadAllText("Pi.txt");
            rchPi.Text = Pi;
            rchPi.Select(0, 0);
            lblPosition.Text = "";
        }

        // Search for a pattern.
        private void btnSearch_Click(object sender, EventArgs e)
        {
            // Get the pattern.
            string pattern = txtPattern.Text;

            // Remove all non-digits.
            Regex reg_exp = new Regex("[^0-9]");
            pattern = reg_exp.Replace(pattern, "");

            // Search for the pattern.
            int position = Pi.IndexOf(pattern);

            // Display the result.
            rchPi.Text = Pi;
            if (position < 0)
                lblPosition.Text = pattern + " was not found";
            else
            {
                lblPosition.Text = pattern + " found at digit " + position.ToString();
                rchPi.Select(position, pattern.Length);
                rchPi.SelectionBackColor = Color.Yellow;
                rchPi.SelectionColor = Color.Red;
                rchPi.ScrollToCaret();
            }
        }
    }
}
